/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  Copyright (c) 2009-2015                                                **
**  German Research School for Simulation Sciences GmbH,                   **
**  Laboratory for Parallel Programming                                    **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/



package scalasca.cubex.cube;
import java.lang.*;
/*
 * Class , delivers file structure of CubeX
 * 
 */
public class Machine extends SystemTreeNode
{

	public Machine() {super(); }
	public Machine(int _id) {super(_id, "Machine", "machine", (SystemTreeNode)null);}
	public Machine(int _id, String _name) {super(_id, _name, "machine", (SystemTreeNode)null);}
	public Machine(int _id, String _name, String _description) {super(_id, _name, _description, "machine", null);  }
	public Machine(SystemTreeNode _clone) 
	{
	  super( _clone.getId(),
		 _clone.getName(),
		 _clone.getDescription(),
		 "machine",
		 (SystemTreeNode)null
	    );
	  for ( Vertex _nodes: _clone.getAllChildren())
	  {
	    children.add( new Node((SystemTreeNode)_nodes, this) );
	  }
	  
	}
}
 