/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  Copyright (c) 2009-2015                                                **
**  German Research School for Simulation Sciences GmbH,                   **
**  Laboratory for Parallel Programming                                    **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/



package scalasca.cubex.cube;
import java.lang.*;
import java.util.*;
/*
 * Class , delivers file structure of CubeX
 * 
 */
public class Vertex extends Ident
{

	protected Vertex parent= null;
	protected ArrayList< Vertex > children= new ArrayList<Vertex> ();
    protected Map<String, String> attributes = new HashMap< String, String > ();
    
//     @SuppressWarnings("unchecked")
	public Vertex() { super(0); parent = null; }
	public Vertex(int _id) { super(_id); parent = null; }
	public Vertex(int _id, Vertex _parent)
			{
				super(_id);
				parent = _parent;
				if (parent != null)
				{
				parent.addChild(this);
				}
			}

	public void addChild(Vertex _child)
	{
		children.add(_child);
	}

	public Vertex getChild(int idx)
	{
	// 	if (idx >0 && idx < children.size())
		return children.get(idx);
	// 	throw new ArrayIndexOutOfBoundsException();
	}

	public int getNumberOfChildren()
	{
		return children.size();
	}

	public Vertex getParent()
	{
		return parent;
	}


    public void def_attr (String key, String value)
    {
        if (key != null)
        {
            attributes.put(key, value);
        }
    }
    
    
    public String get_attr (String key)
    {
        if (key != null)
        {
            return attributes.get(key);
        }else 
        return null;
    }	
	
    public Map<String, String> get_attrs ()
    {
        return attributes;
    }
    
    public void set_attrs (Map<String, String> _attrs)
    {
        attributes=_attrs;
    }   
    
	public ArrayList<Vertex> getAllChildren() { return children; }


}
