/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  Copyright (c) 2009-2015                                                **
**  German Research School for Simulation Sciences GmbH,                   **
**  Laboratory for Parallel Programming                                    **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/




import scalasca.cubex.cube.*;
import scalasca.cubex.cube.errors.*;
import java.util.*;
import java.lang.*;
import java.lang.String;
import java.io.*;
import scalasca.cubex.cube.services.transformation.*;
import scalasca.cubex.cube.datalayout.data.value.*;

/*
 * Test class for BTarInputStream
 *
 */
public class cube_test10
{



	public static void main(String[] args)
	{
        Locale.setDefault(new Locale("C", "C"));
	String cubefile = args[0];
	
	char 	ch = 'A';
	byte 	by = 25;
	short 	sh = 255;
	int 	in = 4463;
	long 	lg = 356457645L;
	double 	db = 34534.345;





	NOP nop = new NOP();
	SwapBytes swap = new SwapBytes();


	Byte 	By = swap.applyOn(by);
	Short 	Sh = swap.applyOn(sh);
	Integer	In = swap.applyOn(in);
	Long 	Lg = swap.applyOn(lg);
	Double 	Db = swap.applyOn(db);
	byte[] 	BB = {12,23,34,45,5,78,45, 11,127};



	for (byte bb: BB)
	{
		System.out.print(bb + " " );
	}
	System.out.println();
	
	byte[] _BB = nop.applyOn(BB);
	for (byte bb: _BB)
	{
		System.out.print(bb + " " );
	}
	System.out.println();

	byte[] __BB = swap.applyOn(BB);
	for (byte bb: __BB)
	{
		System.out.print(bb + " " );
	}
	System.out.println();

//	System.out.println(ch + " -> "+ nop.applyOn(ch) + ", " + swap.applyOn(ch));
	System.out.println(by + " -> " +nop.applyOn(by) + ", " + swap.applyOn(by));
	System.out.println(sh + " -> "+ nop.applyOn(sh) + ", " + swap.applyOn(sh));
	System.out.println(in + " -> "+ nop.applyOn(in) + ", " + swap.applyOn(in));
	System.out.println(lg + " -> "+ nop.applyOn(lg) + ", " + swap.applyOn(lg));
	System.out.println(db + " -> "+ nop.applyOn(db) + ", " + swap.applyOn(db));
	System.out.println(By + " -> "+ nop.applyOn(By) + ", " + swap.applyOn(By));
	System.out.println(Sh + " -> "+ nop.applyOn(Sh) + ", " + swap.applyOn(Sh));
	System.out.println(In + " -> "+ nop.applyOn(In) + ", " + swap.applyOn(In));
	System.out.println(Lg + " -> "+ nop.applyOn(Lg) + ", " + swap.applyOn(Lg));
	System.out.println(Db + " -> "+ nop.applyOn(Db) + ", " + swap.applyOn(Db));

	System.out.println("------------------------------------------------------------");

	CubeInt8 cube_int8_1 = new CubeInt8();
	cube_int8_1.setValue(34);
	CubeInt8 cube_int8_2 = new CubeInt8();
	cube_int8_2.setValue(-45);
	CubeInt8 cube_int8 = new CubeInt8();
	System.out.print(cube_int8_1.toString() + " + " + cube_int8_2.toString() + " = ");
	cube_int8.addValue(cube_int8_1);
	cube_int8.addValue(cube_int8_2);
	System.out.println(cube_int8.toString());

	CubeInt16 cube_int16_1 = new CubeInt16();
	cube_int16_1.setValue(344);
	CubeInt16 cube_int16_2 = new CubeInt16();
	cube_int16_2.setValue(-435);
	CubeInt16 cube_int16 = new CubeInt16();
	System.out.print(cube_int16_1.toString() + " + " + cube_int16_2.toString() + " = ");
	cube_int16.addValue(cube_int16_1);
	cube_int16.addValue(cube_int16_2);
	System.out.println(cube_int16.toString());


	CubeInt32 cube_int32_1 = new CubeInt32();
	cube_int32_1.setValue(3344);
	CubeInt32 cube_int32_2 = new CubeInt32();
	cube_int32_2.setValue(-43465);
	CubeInt32 cube_int32 = new CubeInt32();
	System.out.print(cube_int32_1.toString() + " + " + cube_int32_2.toString() + " = ");
	cube_int32.addValue(cube_int32_1);
	cube_int32.addValue(cube_int32_2);
	System.out.println(cube_int32.toString());


	CubeInt64 cube_int64_1 = new CubeInt64();
	cube_int64_1.setValue(3467344);
	CubeInt64 cube_int64_2 = new CubeInt64();
	cube_int64_2.setValue(-452356);
	CubeInt64 cube_int64 = new CubeInt64();
	System.out.print(cube_int64_1.toString() + " + " + cube_int64_2.toString() + " = ");
	cube_int64.addValue(cube_int64_1);
	cube_int64.addValue(cube_int64_2);
	System.out.println(cube_int64.toString());


	CubeUint8 cube_uint8_1 = new CubeUint8();
	cube_uint8_1.setValue(34);
	CubeUint8 cube_uint8_2 = new CubeUint8();
	cube_uint8_2.setValue(35);
	CubeUint8 cube_uint8 = new CubeUint8();
	System.out.print(cube_uint8_1.toString() + " + " + cube_uint8_2.toString() + " = ");
	cube_uint8.addValue(cube_uint8_1);
	cube_uint8.addValue(cube_uint8_2);
	System.out.println(cube_uint8.toString());

	CubeUint16 cube_uint16_1 = new CubeUint16();
	cube_uint16_1.setValue(344);
	CubeUint16 cube_uint16_2 = new CubeUint16();
	cube_uint16_2.setValue(535);
	CubeUint16 cube_uint16 = new CubeUint16();
	System.out.print(cube_uint16_1.toString() + " + " + cube_uint16_2.toString() + " = ");
	cube_uint16.addValue(cube_uint16_1);
	cube_uint16.addValue(cube_uint16_2);
	System.out.println(cube_uint16.toString());


	CubeUint32 cube_uint32_1 = new CubeUint32();
	cube_uint32_1.setValue(3344);
	CubeUint32 cube_uint32_2 = new CubeUint32();
	cube_uint32_2.setValue(2465);
	CubeUint32 cube_uint32 = new CubeUint32();
	System.out.print(cube_uint32_1.toString() + " + " + cube_uint32_2.toString() + " = ");
	cube_uint32.addValue(cube_uint32_1);
	cube_uint32.addValue(cube_uint32_2);
	System.out.println(cube_uint32.toString());


	CubeUint64 cube_uint64_1 = new CubeUint64();
	cube_uint64_1.setValue(467344);
	CubeUint64 cube_uint64_2 = new CubeUint64();
	cube_uint64_2.setValue(252356);
	CubeUint64 cube_uint64 = new CubeUint64();
	System.out.print(cube_uint64_1.toString() + " + " + cube_uint64_2.toString() + " = ");
	cube_uint64.addValue(cube_uint64_1);
	cube_uint64.addValue(cube_uint64_2);
	System.out.println(cube_uint64.toString());

	

	CubeDouble cube_double_1 = new CubeDouble();
	cube_double_1.setValue(467.344);
	CubeDouble cube_double_2 = new CubeDouble();
	cube_double_2.setValue(2523.56);
	CubeDouble cube_double = new CubeDouble();
	System.out.print(cube_double_1.toString() + " + " + cube_double_2.toString() + " = ");
	cube_double.addValue(cube_double_1);
	cube_double.addValue(cube_double_2);
	System.out.println(cube_double.toString());

	CubeMinDouble cube_min_double_1 = new CubeMinDouble();
	cube_min_double_1.setValue(467.344);
	CubeMinDouble cube_min_double_2 = new CubeMinDouble();
	cube_min_double_2.setValue(2523.56);
	CubeMinDouble cube_min_double = new CubeMinDouble();
	System.out.print(cube_min_double_1.toString() + " + " + cube_min_double_2.toString() + " = ");
	cube_min_double.addValue(cube_min_double_1);
	cube_min_double.addValue(cube_min_double_2);
	System.out.println(cube_min_double.toString());


	CubeMaxDouble cube_max_double_1 = new CubeMaxDouble();
	cube_max_double_1.setValue(467.344);
	CubeMaxDouble cube_max_double_2 = new CubeMaxDouble();
	cube_max_double_2.setValue(2523.56);
	CubeMaxDouble cube_max_double = new CubeMaxDouble();
	System.out.print(cube_max_double_1.toString() + " + " + cube_max_double_2.toString() + " = ");
	cube_max_double.addValue(cube_max_double_1);
	cube_max_double.addValue(cube_max_double_2);
	System.out.println(cube_max_double.toString());


	CubeComplex cube_complex_1 = new CubeComplex(34,62.4);
	CubeComplex cube_complex_2 = new CubeComplex(-34.7, 354.3);
	CubeComplex cube_complex = new CubeComplex();
	System.out.print(cube_complex_1.toString() + " + " + cube_complex_2.toString() + " = ");
	cube_complex.addValue(cube_complex_1);
	cube_complex.addValue(cube_complex_2);
	System.out.println(cube_complex.toString());

	CubeTauAtomicMetric cube_tau_atomic_1 = new CubeTauAtomicMetric(5,-3, 8, 19, 149);
	CubeTauAtomicMetric cube_tau_atomic_2 = new CubeTauAtomicMetric(3, -10, 9, 0, 182);
	CubeTauAtomicMetric cube_tau_atomic = new CubeTauAtomicMetric();
	System.out.print(cube_tau_atomic_1.toString() + " + " + cube_tau_atomic_2.toString() + " = ");
	cube_tau_atomic.addValue(cube_tau_atomic_1);
	cube_tau_atomic.addValue(cube_tau_atomic_2);
	System.out.println(cube_tau_atomic.toString());



		Cube cube = new Cube();
		try
		{
			cube.openCubeReport(cubefile);

			ArrayList<scalasca.cubex.cube.Metric> metrics = cube.get_metv();
			ArrayList<scalasca.cubex.cube.Metric> root_metrics = cube.get_root_metv();
			ArrayList<scalasca.cubex.cube.Region> regions = cube.get_regionv();
			ArrayList<scalasca.cubex.cube.Cnode> cnodes = cube.get_cnodev();
			ArrayList<scalasca.cubex.cube.Cnode> root_cnodes = cube.get_root_cnodev();
			ArrayList<scalasca.cubex.cube.SystemTreeNode> machines = cube.get_root_stnv();
			ArrayList<scalasca.cubex.cube.SystemTreeNode> nodes = cube.get_stnv();
			ArrayList<scalasca.cubex.cube.LocationGroup> process = cube.get_location_groupv();
			ArrayList<scalasca.cubex.cube.Location> threads = cube.get_locationv();


			System.out.println(
					"Metrics:" + metrics.size() + "\n" +
					"Root Metrics:" + root_metrics.size() + "\n" +
					"Regions:" + regions.size() + "\n" +
					"Cnodes:" + cnodes.size() + "\n" +
					"Machines:" + machines.size() + "\n" +
					"Nodes:" + nodes.size() + "\n" +
					"Processes:" + process.size() + "\n" +
					"Threads:" + threads.size() + "\n"
					  );
			System.out.println("-------------------------");
			for (scalasca.cubex.cube.Metric met : root_metrics)
			{
				printMetrics(met, 0);
			}
			System.out.println("-------------------------");
			for (scalasca.cubex.cube.Region reg : regions)
			{
				printRegion(reg);
			}
			System.out.println("-------------------------");
			for (scalasca.cubex.cube.Cnode cnode : root_cnodes)
			{
				printCnodes(cnode, 0);
			}
			System.out.println("-------------------------");
			for (scalasca.cubex.cube.SystemTreeNode machine : machines)
			{
				printSTN(machine);
			}





			for (scalasca.cubex.cube.Metric met: metrics)
			{
				System.out.println(" ================================ Metric "+met.getDisplayName() + " ============================");
				for (scalasca.cubex.cube.Cnode cnode: cnodes)
				{
					System.out.println(" -------------------------------- Cnode "+cnode.getName() + " ----------------------------");
					for (scalasca.cubex.cube.Location thread: threads)
					{
// 						cube.set_sev(met, cnode, thread, "-12.454");
						System.out.format("%.3f ", cube.get_sev_adv(met, cnode, thread).getDouble());
					}System.out.println();
				}
			}




		}catch (BadSyntaxException e)
		{
			System.out.println("Bad syntax error:" + e.getMessage());
		}catch (BadCubeReportLayoutException e)
		{
			System.out.println("Bad layout error:" + e.getMessage());
		}catch (IOException e)
		{
			System.out.println("IO Error: " + e.getMessage());
		}catch (Exception e)
		{
			System.out.println("General error:" + e.getMessage());
		}
	}




	static public void printMetrics(Metric met, int ident)
	{
		printIdentSpaces(ident);
		System.out.println(met.getUniqName());
		for (Object _met: met.getAllChildren().toArray())
		{
			printMetrics((Metric)_met, ident + 1);
		}
	}	


	static public void printRegion(Region reg)
	{
		printIdentSpaces(1);
		System.out.println(reg.getName());
	}



	static public void printCnodes(Cnode cnode, int ident)
	{
		printIdentSpaces(ident);
		System.out.println(cnode.getRegion().getName());
		for (Object _cnode: cnode.getAllChildren().toArray())
		{
			printCnodes((Cnode)_cnode, ident + 1);
		}
	}


	static public void printSTN(SystemTreeNode machine)
	{
		printIdentSpaces(1);
		System.out.println(machine.getName());
		for (Object _node: machine.getAllChildren().toArray())
		{
			printSTN((SystemTreeNode)_node);
		}
                for (Object _node: machine.getAllGroups().toArray())
		{
			printLG((LocationGroup)_node);
		}
	}



	static public void printLG(scalasca.cubex.cube.LocationGroup process)
	{
		printIdentSpaces(3);
		System.out.println(process.getName());
		for (Object _thread: process.getAllChildren().toArray())
		{
			printLocation((scalasca.cubex.cube.Location)_thread);
		}
	}

	static public void printLocation(scalasca.cubex.cube.Location thread)
	{
		printIdentSpaces(4);
		System.out.println(thread.getName());
	}


	static private void printIdentSpaces(int num)
	{
		for(int i=0; i< num; i++)
			System.out.print("\t");
	}





}
